'****************************************************************************************
'**** Script de configuration automatique de la signature Outlook.
'**** Date : 04/11/2013
'**** Test avec : Outlook 2003, 2010, 2013 Serveur Windows Server 2008R2 et Exchange 2010.
'**** Origine : Alexandre FONTON, www.nalex.fr
'**** Modifi par Martial AUROY.
'****************************************************************************************


'##########################################################
'#### Lignes de configuration :


' Indiquer le nom des signatures utilises dans Outlook et pour nommer les fichiers htm, rtf et txt
' Si vous voulez en publier plusieurs, ajouter des noms  cette collection
TAB_NOM_SIGNATURE = array("SIGNATURE_001")

' Indiquer le rpertoire source contenant le modle de la signature (gnralement un emplacement rseau).
' mieux que l'UNC, utiliser la commande NET pour associer un drive le temps de l'execution du script
REP_MODELE_SIGNATURE = "Y:\SignaturesOutlook2013" 

'Lister les fichiers images necessaires pour la signature HTML.
TAB_FICHIERS_IMAGES = array("", "")

'Liste des variables  rsoudre via l'annuaire Active Directory
'   Colonne 1 : Nom des variables prsentes dans les fichiers htm, rtf et txt.
'   Colonne 2 : Nom du champ Active Directory  utiliser  la place de la variable.
'   Colonne 3 : Nom du champ Active Directory  utiliser si le prcdent champ n'est pas renseign dans le compte utilisateur.
'   Colonne 4 : Prefixe  ajouter pour l'HTML
'   Colonne 5 : Suffixe  ajouter pour l'HTML
'   Colonne 6 : reste vide, sert  la reconstruction
strPrefixMobile =  "<br/><span style='font-size:9.0pt;mso-ascii-font-family:Calibri;mso-fareast-font-family:""Calibri"";mso-hansi-font-family:Calibri;color:black;mso-themecolor:text1'><span style='color:black;mso-themecolor:text1;text-decoration:none;text-underline:none'><!--[if gte vml 1]><v:shape id=""_x0000_i1027"" type=""#_x0000_t75"" style='width:12pt;height:12pt'><v:imagedata src=""#FICHIERS#/image004.gif"" o:title=""image004""/></v:shape><![endif]--><![if !vml]><img border=0 width=16 height=16 src=""#FICHIERS#/image004.gif"" v:shapes=""_x0000_i1027""><![endif]></span><span style='color:black;mso-themecolor:text1'>"
strSuffixMobile =  "</span></span>"
strPrefixEmail  =  "<br/><span style='font-size:9.0pt;mso-ascii-font-family:Calibri;mso-fareast-font-family:""Calibri"";mso-hansi-font-family:Calibri;color:black;mso-themecolor:text1'><a href=""mailto:#EMAILONLY#""><span style='color:black;mso-themecolor:text1;text-decoration:none;text-underline:none'><!--[if gte vml 1]><v:shape id=""_x0000_i1028"" type=""#_x0000_t75"" style='width:12pt;height:12pt'><v:imagedata src=""#FICHIERS#/image005.gif"" o:title=""image006""/></v:shape><![endif]--><![if !vml]><img border=0 width=16 height=16 src=""#FICHIERS#/image005.gif"" v:shapes=""_x0000_i1028""><![endif]></span><span style='color:black;mso-themecolor:text1'>"
strSuffixEmail  =  "</span></a></span>"
TAB_VARIABLES =  array( array("#PRENOM#", "givenName"       , ""    , "" , "", ""), _
                        array("#NOM#"    , "sn"             , ""    , "" , "", ""), _
						array("#TITRE#" , "title"           , ""    , "" , "", ""), _
						array("#TEL#"   , "telephoneNumber" , ""    , "" , "", ""), _
						array("#DEPARTMENT#", "department"     , ""    , "" , "", ""), _
						array("#EMAIL#" , "mail"            , ""    , strPrefixEmail , strSuffixEmail , ""), _
						array("#MOBILE#", "mobile"          , ""    , strPrefixMobile, strSuffixMobile, ""), _
						array("#EMAILONLY#" , "mail"        , ""    , "" , "", "") _ 
					  )

					  
'##########################################################
'#### lancement du traitement.		  
If Not IsOutlookRunning Then
    for nsig=0 to UBound(TAB_NOM_SIGNATURE)
wscript.echo "##########################################################"
    '*** Copie et personalisation des fichiers de signature dans "%USERPROFILE%\Application Data\Microsoft\Signatures".
        Call getLdapProfileAndCopyFiles(REP_MODELE_SIGNATURE, TAB_NOM_SIGNATURE(nsig), TAB_FICHIERS_IMAGES, TAB_VARIABLES)
    '*** Dfinition de la nouvelle signature par dfaut dans Outlook.
        Call SetDefaultSignature(TAB_NOM_SIGNATURE(nsig))
    Next
'else
'        strMsg = "Veuillez fermer Outlook avant d'executer ce script"
'        MsgBox strMsg, vbExclamation, "SetDefaultSignature"
End If


'##########################################################
'#### Fonctions VBS.
' /**
' * Fonction GetOsName()
' *  renvoi la chaine de la version de windows
' * @author : M. AUROY
' * @date : 10/08/2010
function GetOsName() 
' recherche de la version de l'OS
wscript.echo "recherche la version de l'OS"
strComputer = "."
strResultat=""
Set objWMIService = GetObject("winmgmts:" _
    & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
Set colOperatingSystems = objWMIService.ExecQuery _
    ("Select * from Win32_OperatingSystem")
For Each objOperatingSystem in colOperatingSystems
    strResultat=strResultat &  objOperatingSystem.Caption
Next
dim start 
dim length
strResultat = ucase(strResultat)
if InStr(1,strResultat,"8") >0 then GetOsName="EIGHT"
if InStr(1,strResultat,"7") >0 then GetOsName="SEVEN"
if InStr(1,strResultat,"VISTA") >0 then GetOsName="VISTA"
if InStr(1,strResultat,"XP") >0 then GetOsName="XP"
'msgbox(strResultat)
end function
' --------------

' /**
' * Fonction GetOutlookVersion()
' *  renvoi la version d'outlook si outlook existe
' * @author : M. AUROY
' * @date : 10/08/2010
function GetOutlookVersion()
    GetOutlookVersion=""
    Dim oOutlook 
    Dim oulookVersion 
    set oOutlook = CreateObject("Outlook.Application")
    GetOutlookVersion = Cstr(Left(oOutlook.Version, 4)) 'for exemple : "15.0"
  end function
' --------------

' /**
' * Fonction FindFile()
' * renvoi le chemin du fichier recherch ("chemin  partir de", "nom du fichier avec extension")
' * @author : M. AUROY
' * @date : 10/08/2010
function FindFile(strFolder,strFile)
    On ERROR Resume Next
    FindFile = ""
    Dim File
    Dim Folder
    Set System = CreateObject("Scripting.FileSystemObject")

    For Each Folder In System.GetFolder(strFolder).SubFolders
        ' si non system
        if (  ((Folder.attributes And 4) <> 4)   )then 
            For Each File In Folder.Files
                If LCase(File.Name) = LCase(strFile) Then
                    FindFile = File
                exit function
                End If
            Next 'File
        end if
        FindFile = FindFile(Folder,strFile)
        if FindFile <>"" then exit function
    Next 'Folder
END function
' --------------

' /**
' * Fonction getLdapProfileAndCopyFiles()
' *  Copie des fichiers de ressources graphiques du rpertoire rseau
' * @param string strSigName Nom de la signature Outlook
' * @param string signatureName Nom de la signature (prsent dans la liste des signature Outlook et utilise pour nommer les fichiers de signature).
' * @param array tFichiersImages Tableau 1D contenant les noms des fichiers images necessaires pour la signature HTML (ne pas indiquer de rpertoire)
' * @param array tVariables Tableau 2D contenant la liste des variables  remplacer par une valeur issue de AD.
' * Algo :
' *  1- Vrifie que Outlook est ferm.
' *  2- Utilisation de WMI pour accder en criture  la base de registre.
' *  3- Rcupre le nom des profils Outlook utiliss.
' *  4- Affectation du nom de signature  tous les profils
'**/
Sub getLdapProfileAndCopyFiles(baseRepSrc, signatureName, tFichiersImages, tVariables)
  Dim htlmFile, htmlFileDest
  Set dtmConvertedDate = CreateObject("WbemScripting.SWbemDateTime")
  Set WshShell = WScript.CreateObject("WScript.Shell")
  repProfil = WshShell.ExpandEnvironmentStrings("%USERPROFILE%")

wscript.echo "SIGNATURE est : """ & signatureName & """"
wscript.echo "Repertoire profile " & CStr(repProfil)
wscript.echo "L'OS est : """ & GetOsName() & """"
wscript.echo "Version d'Outlook " & GetOutlookVersion

Select case GetOsName()
    case "XP":
        repSignatures = repProfil & "\Application Data\Microsoft\Signatures"
    case "EIGHT","SEVEN", "VISTA":
        repSignatures = repProfil & "\AppData\Roaming\Microsoft\Signatures"
    case else:
        'msgbox("l'OS n'est pas rpertori dans ce programme, contactez le service technique. Merci.")
    exit sub
End Select

wscript.echo "Le repertoire des signatures est " & repSignatures

  '*** Cration du rpertoire Signature, si aucune signature n'a t cr par le pass.
  Set objFSO = CreateObject("Scripting.FileSystemObject")
  if  objFSO.FolderExists(repSignatures) = False then
        wscript.echo "Cration du rpertoire " & repSignatures
		objFSO.CreateFolder (repSignatures)
  End if
 

  '*** Copie le rpertoire neccessaire pour la signature.
  Dim RepSource
  Dim RepCible
  RepSource = baseRepSrc & "\" &  signatureName & "_Fichiers" 
  RepCible = repSignatures & "\" &  signatureName & "_Fichiers"
  wscript.echo "Le repertoire 'source' est " & RepSource
  wscript.echo "Le repertoire 'cible' est " & RepCible

  '*** Cration du sous rpertoire contenant les fichier lis  la signature
  if  objFSO.FolderExists(RepCible) = False then
        wscript.echo "Cration du sous rpertoire " & RepCible & " contenant les fichier lis  la signature"
		objFSO.CreateFolder (RepCible)
  End if
  wscript.echo "Copie le rpertoire " & RepSource & "neccessaire pour la signature dans " & RepCible & " ..."
  call objFSO.CopyFolder (RepSource, RepCible ,TRUE)
 
'   '*** Copie le rpertoire neccessaire pour la signature.
'  For Each image In tFichiersImages
'		Call objFSO.CopyFile(baseRepSrc & "\" & image, repSignatures & "\" & image)
'  Next

  '*** Prparation des noms de fichiers de signatures gnriques  copier
  htlmFile = 	 baseRepSrc & "\" & signatureName & ".htm"
  htmlFileDest = repSignatures & "\" & signatureName & ".htm"
  rtfFile = 	 baseRepSrc & "\" & signatureName & ".rtf"
  rtfFileDest =  repSignatures & "\" & signatureName & ".rtf"
  txtFile =		 baseRepSrc & "\" & signatureName & ".txt"
  txtFileDest =  repSignatures & "\" & signatureName & ".txt"

  '*** Copie des fichiers de signatures gnriques
  strUserInfo = getStrUserInfo()
  result = replaceLdapUserInfoInFile(strUserInfo, htlmFile, htmlFileDest, tVariables,"HTML", signatureName)
  result = replaceLdapUserInfoInFile(strUserInfo, rtfFile, rtfFileDest, tVariables,"RTF",signatureName)
  result = replaceLdapUserInfoInFile(strUserInfo, txtFile, txtFileDest, tVariables,"TXT",signatureName)

  Set objFSO = Nothing

End Sub

' /**
' * Fonction SetDefaultSignature()
' *  Activation de la signature Outlook nomme dans la variable strSigName.
' * @param string strSigName Nom de la signature Outlook
' * @author : A. FONTON
' * @date : 26/09/2008
' * Algo :
' *  1- Vrifie que Outlook est ferm.
' *  2- Utilisation de WMI pour accder en criture  la base de registre.
' *  3- Rcupre le nom des profils Outlook utiliss.
' *  4- Affectation du nom de signature  tous les profils
'**/
Sub SetDefaultSignature(strSigName)
    Const HKEY_CURRENT_USER = &H80000001
    strComputer = "."

    '--- If outlook is closed
    If Not IsOutlookRunning Then
        ' Acces WMI au registre.
        Set objreg = GetObject("winmgmts:{impersonationLevel=impersonate}!\\" & strComputer & "\root\default:StdRegProv")
        ' Emplacement parent dans le registre  utiliser.
        'strKeyPath = "Software\Microsoft\Windows NT\CurrentVersion\Windows Messaging Subsystem\Profiles\"
        strKeyPath = "Software\Microsoft\Office\" & GetOutlookVersion() & "\Common\MailSettings"
        ' Nom du profil Outlook par dfaut.
        'objreg.GetStringValue HKEY_CURRENT_USER, strKeyPath, "DefaultProfile", strProfile

        ' Converti le nom du profile en tableau de "Byte".
        'myArray = StringToByteArray(strSigName, True)
        '
        'strKeyPath = strKeyPath & strProfile & "\9375CFF0413111d3B88A00104B2A6676"
        'objreg.EnumKey HKEY_CURRENT_USER, strKeyPath, arrProfileKeys

'        For Each subkey In arrProfileKeys
'            strsubkeypath = strKeyPath & "\" & subkey
'            'On Error Resume Next
'            objreg.SetBinaryValue HKEY_CURRENT_USER, strsubkeypath, "New Signature", myArray
'            objreg.SetBinaryValue HKEY_CURRENT_USER, strsubkeypath, "Reply-Forward Signature", myArray
'            'MsgBox  strsubkeypath
'        Next
        objreg.SetStringValue HKEY_CURRENT_USER, strKeyPath, "New Signature", strSigName
        objreg.SetStringValue HKEY_CURRENT_USER, strKeyPath, "Reply-Forward Signature", strSigName
    Else
        strMsg = "Please shut down Outlook before running this script."
        'MsgBox strMsg, vbExclamation, "SetDefaultSignature"
    End If
End Sub


' /**
' *  Activation de la signature Outlook nomme dans la variable strSigName.
' * @param string strSigName Nom de la signature Outlook
'**/
Function IsOutlookRunning()
    strComputer = "."
    strQuery = "Select * from Win32_Process " & _
               "Where Name = 'Outlook.exe'"
    Set objWMIService = GetObject("winmgmts:" _
        & "{impersonationLevel=impersonate}!\\" _
        & strComputer & "\root\cimv2")
    Set colProcesses = objWMIService.ExecQuery(strQuery)
    For Each objProcess In colProcesses
        If UCase(objProcess.Name) = "OUTLOOK.EXE" Then
            IsOutlookRunning = True
        Else
            IsOutlookRunning = False
        End If
    Next
End Function

Public Function StringToByteArray _
                 (Data, NeedNullTerminator)
    Dim strAll
    strAll = StringToHex4(Data)
    If NeedNullTerminator Then
        strAll = strAll & "0000"
    End If
    intLen = Len(strAll) \ 2
    ReDim arr(intLen - 1)
    For i = 1 To Len(strAll) \ 2
        arr(i - 1) = CByte _
                   ("&H" & Mid(strAll, (2 * i) - 1, 2))
    Next
    StringToByteArray = arr
End Function

Public Function StringToHex4(Data)
    ' Input: normal text
    ' Output: four-character string for each character,
    '         e.g. "3204" for lower-case Russian B,
    '        "6500" for ASCII e
    ' Output: correct characters
    ' needs to reverse order of bytes from 0432
    Dim strAll
    For i = 1 To Len(Data)
        ' get the four-character hex for each character
        strChar = Mid(Data, i, 1)
        strTemp = Right("00" & Hex(AscW(strChar)), 4)
        strAll = strAll & Right(strTemp, 2) & Left(strTemp, 2)
    Next
    StringToHex4 = strAll
End Function


'***********************************************************************************
'**** Fonction : getStrUserInfo                         ****
'**** Rle : Renvois une chane contenant les informations sur l'utilisateur    ****
'**** Recois : Rien                                                             ****
'**** Renvois : une chane de caractres.                                       ****
'**** Exemple : "CN=Alexandre Fonton,OU=Informatique,OU=Service-Technique,      ****
'****                   OU=Users,OU=Vulcania,DC=semvolcans,DC=com"          ****
'************************************************************************************
Function getStrUserInfo()
   Dim ADSysInfo  '// Objet contenant les informations rseau de l'utilisateur.
        '----- obtient les paramtres de d'utilisateur ------
        Set ADSysInfo = CreateObject("ADSystemInfo")
        getStrUserInfo = ADSysInfo.UserName
End Function


'***********************************************************************************
'**** Fonction : replaceLdapUserInfoInFile                                   
'**** Rle : Intgre les informations LDAP dans le fichier.                     
'**** @param userLdapInfo Objet LDAP.                                           
'**** @param file Nom du fichier source  modifier.                                    
'**** @param String fileDest Chemin et nom du fichier de destination
'**** @param Array tVariables  Tableau 2D contenant la liste des variables  remplacer par une valeur issue de AD
'**** @strType HTML, RTF ou TXT pour le type de fichier
'**** @strSignatureName le nom de la signature en cours
'**** Renvois : une chane de caractres.                                       
'************************************************************************************
Function replaceLdapUserInfoInFile(strUserInfo, fileModele, fileDest, tVariables, strType, strSignatureName)
    Dim userLdapInfo
    Dim objFSO, objFile
    Const ForReading = 1
    Const ForWriting = 2

    
	Set userLdapInfo = GetObject("LDAP://" & strUserInfo)
    '--- Lecture des champs de la fiche LDAP de l'utilisateur courant.
    '--- La gestion d'erreur permet de grer les cas ou un champ n'est pas renseign dans AD.
  
	'*** Rsolution des variables via l'annuaire Active Directory.

	For i = 0 To UBound(tVariables)
		On Error Resume Next
		Err.Number = 0
			tVariables(i)(5) = userLdapInfo.Get(tVariables(i)(1))
			' Si ce paramtre AD  est introuvable, on prend la valeur par dfaut.
			If (Err.Number <> 0) Then
				tVariables(i)(5) = userLdapInfo.Get(tVariables(i)(2))
			End If
    		'si on a trouv un lment, on ajoute le prfixe et le suffixe HTML
            if (tVariables(i)(5)<>"" and strType="HTML") then
    			tVariables(i)(5) = tVariables(i)(3) & tVariables(i)(5) & tVariables(i)(4)
            end if
		On Error GoTo 0 ' Invalide la gestion d'erreur
	Next
    

'	'--- Boucle de debug.
'	For Each variable In tVariables 
'		MsgBox	variable(0) & " : " & variable(1)  & " : " & variable(5)
'	Next


	'*** Lecture du fichier modle et copie de son contenu dans la variable strText.
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set objFile = objFSO.OpenTextFile(fileModele, ForReading)
	strText = objFile.ReadAll
	objFile.Close

	
	'*** Substitution des variables du type #DONNEE# par leurs valeurs issus de l'objet LDAP utilisateur.
	For Each variable In tVariables 
			strText = Replace( strText, variable(0), variable(5))
			'MsgBox	variable(0) & " <=> " & variable(5)
	Next
    
    '*** Substitution du dossier d'images 
	strText = Replace( strText, "#FICHIERS#",strSignatureName & "_fichiers" )

	'*** Suppression du fichier de signature si il existait dj.
	If objFSO.FileExists(fileDest) = True Then
		objFSO.DeleteFile fileDest, 1
        'MsgBox "fichier " & fileDest & " effac."
	End If

	'*** Cration du fichier de signature.
	Set objFile = Nothing
    Set objFile = objFSO.CreateTextFile(fileDest,true) 'overright if needed 

	'*** Ecriture du contenu du fichier de signature personnalis.
    'MsgBox (fileDest & "-" & strText)
    objFile.WriteLine strText

	objFile.Close
	Set objFSO = Nothing
	
End Function

